/**
 | ee244 assignment 2 - fall 1996 - Prof. Newton
 | Simulated Annealing and Mincut Cell Placement
 |
 | James Young and Suzan Szollar
 |
 | ProgressBar.java
 |
 */

/*
 *	Pops up a progress bar and animates it.
 */

import java.awt.*;
import java.applet.*;

//////////////////////////////////////////////////////////////////////////////

class ProgressBar
	extends Frame
	implements Runnable
{

	//* Variables
	private final static Dimension winSize = new Dimension(150, 140);
	private Progressable target;
	private long delay;
	PBarCanvas myCanvas;

	//* Constructors
	public ProgressBar(Progressable target) {
	    this(target,1000);
	}

	public ProgressBar(Progressable target, long delay) {

		super("Progress");

		this.target = target;
		this.delay = delay;

		myCanvas = new PBarCanvas(target);

		addNotify();
		setLayout(new FlowLayout());
		add(myCanvas);

		resize(winSize);
		show();
		resize(winSize);

		new Thread(this).start();
	}

	//* Methods
	public Dimension minimumSize() { return winSize; }
	public Dimension preferredSize() { return winSize; }

	public void run() {
	    while (target.finished() == false) {
	    	myCanvas.repaint();
			try {
				Thread.sleep(delay);
			} catch (InterruptedException e) {}
		}
		hide();
		dispose();
	}
}